// u_21_invoke
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_21_invoke;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Memo1: TMemo;
    ap_integer_: TButton;
    ap_: TButton;
    procedure_: TButton;
    n_ap_integer_: TButton;
    n_ap_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure ap_integer_Click(Sender: TObject);
    procedure ap_Click(Sender: TObject);
    procedure n_ap_Click(Sender: TObject);
    procedure procedure_Click(Sender: TObject);
    procedure n_ap_integer_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_display_simple;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        Left:= 170; Top:= 110;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    // --

    procedure compute;
      begin
      end; // compute

    procedure process();
      begin
      end; // process

    procedure TForm1.procedure_Click(Sender: TObject);
      begin
        compute;
        compute();
        process;
        process();
      end; // procedure_Click

    type t_ap= reference to procedure;
         t_ap_integer= reference to procedure(p_n: Integer);

    function f_ap: t_ap;
      var l_integer: Integer;
      begin
        l_integer:= 100;
        Result:=
            procedure
              begin
                l_integer:= l_integer;
                display(IntToStr (l_integer));
              end;
      end; // f_ap

    procedure TForm1.ap_Click(Sender: TObject);
      var l_ap: t_ap;
      begin
        display('');
        display('l_ap  NO');
(*
        l_ap:= f_ap;
        l_ap;
*)
        display('l_ap');
        l_ap:= f_ap();
        l_ap;

        display('f_ap()');
        f_ap();
        display('f_ap()()');
        f_ap()();
        display('f_ap().Invoke');
        f_ap().Invoke;
        display('f_ap.Invoke');
        f_ap.Invoke;
      end; // ap_Click

    function f_n_ap(p_total: Integer): t_ap;
      begin
        Result:=
            procedure
              begin
                p_total:= p_total+ 3;
                display(IntToStr(p_total));
              end;
      end; // f_n_ap

    procedure TForm1.n_ap_Click(Sender: TObject);
      var l_ap: t_ap;
      begin
        display('');
        display('l_ap  NO');
(*
        l_ap:= f_n_ap;
        l_ap;
*)
        display('l_ap(20)');
        l_ap:= f_n_ap(20);
        l_ap;

        display('f_n_ap(20)');
        f_n_ap(20);
        display('f_n_ap(20)()');
        f_n_ap(20)();
        display('f_n_ap(20).Invoke');
        f_n_ap(20).Invoke;
        display('f_n_ap.Invoke NO');
(*
        f_n_ap.Invoke;
*)
      end; // n_ap_Click

    function f_ap_integer: t_ap_integer;
      var l_integer: Integer;
      begin
        l_integer:= 100;
        Result:=
            procedure (p_n: Integer)
              begin
                l_integer:= l_integer + p_n;
                display(IntToStr (l_integer));
              end;
      end; // f_ap_integer

    procedure TForm1.ap_integer_Click(Sender: TObject);
      var l_ap_integer: t_ap_integer;
      begin
        display('l_ap_integer(3)');
        l_ap_integer:= f_ap_integer();
        l_ap_integer(3);

        display('f_ap_integer()');
        f_ap_integer();
        display('f_ap_integer()(3)');
        f_ap_integer()(3);
        display('f_ap_integer().Invoke(3)');
        f_ap_integer().Invoke(3);
        display('f_ap_integer.Invoke(3)');
        f_ap_integer.Invoke(3);
      end; // ap_integer_Click

    function f_n_ap_integer(p_total: Integer): t_ap_integer;
      begin
        Result:=
            procedure (p_n: Integer)
              begin
                p_total:= p_total + p_n;
                display(IntToStr(p_total));
              end;
      end; // f_ap_integer

    procedure TForm1.n_ap_integer_Click(Sender: TObject);
      var l_ap_integer: t_ap_integer;
      begin
        display('l_ap_integer(3)');
        l_ap_integer:= f_n_ap_integer(20);
        l_ap_integer(3);

        display('f_n_ap_integer(20)');
        f_n_ap_integer(20);
        display('f_n_ap_integer(20)(3)');
        f_n_ap_integer(20)(3);
        display('f_n_ap_integer(20).Invoke(3)');
        f_n_ap_integer(20).Invoke(3);
        display('f_n_ap_integer.Invoke(3) NO');
(*
        f_n_ap_integer.Invoke(3);
*)
      end; // n_ap_integer_Click

    end.

